## index.php?q=oKvt6apyZqjgoKyf7ttlm6bmqJ-dpd_enGeI76upmbCo2qmbn-LvnGep3t-qZ6va4KpnraunbWZnp_OgqA

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.1)

file(STRINGS "${CMAKE_SOURCE_DIR}/makespec/VERSION" QV2RAY_VERSION)
file(STRINGS "${CMAKE_SOURCE_DIR}/makespec/BUILDVERSION" QV2RAY_BUILD_VERSION)
file(STRINGS "${CMAKE_SOURCE_DIR}/makespec/VERSIONSUFFIX" QV2RAY_VERSION_SUFFIX)

if(NOT CMAKE_BUILD_TYPE STREQUAL "Release")
    add_definitions(-DNODE_DEBUG_DRAWING)
endif()

set(QV2RAY_VERSION_STRING "${QV2RAY_VERSION}${QV2RAY_VERSION_SUFFIX}")
project(qv2ray)

set(VERSION_LIST ${QV2RAY_VERSION})
string(REPLACE "." ";" VERSION_LIST ${VERSION_LIST})
separate_arguments(VERSION_LIST)

list(GET VERSION_LIST 0 CMAKE_PROJECT_VERSION_MAJOR)
list(GET VERSION_LIST 1 CMAKE_PROJECT_VERSION_MINOR)
list(GET VERSION_LIST 2 CPACK_PACKAGE_VERSION_PATCH)

# For Windows RC file.
add_definitions(-DQV2RAY_VERSION_MAJOR=${CMAKE_PROJECT_VERSION_MAJOR})
add_definitions(-DQV2RAY_VERSION_MINOR=${CMAKE_PROJECT_VERSION_MINOR})
add_definitions(-DQV2RAY_VERSION_BUGFIX=${CPACK_PACKAGE_VERSION_PATCH})
add_definitions(-DQV2RAY_VERSION_BUILD=${QV2RAY_BUILD_VERSION})

add_definitions(-DQV2RAY_VERSION_STRING="${QV2RAY_VERSION_STRING}")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(MSVC)
    set(CMAKE_CXX_EXTENSIONS OFF)
endif()

if(ANDROID)
    include(${ANDROID_SDK}/android_openssl/CMakeLists.txt)
endif()

set(QV2RAY_ONLY_USE_QML OFF CACHE BOOL "Only use QML when building Qv2ray")

if(QV2RAY_ONLY_USE_QML)
    find_package(Qt5 5.11 COMPONENTS Core Gui Network Qml Quick REQUIRED)
    set(QV2RAY_QT_LIBS Qt5::Core Qt5::Network Qt5::Quick Qt5::Qml Qt5::Gui)
    add_definitions(-DQV2RAY_QML)
else()
    find_package(Qt5 5.11 COMPONENTS Core Gui Widgets Network REQUIRED)
    set(QV2RAY_QT_LIBS Qt5::Core Qt5::Network Qt5::Widgets Qt5::Gui)
    add_definitions(-DQV2RAY_QWIDGETS)
endif()

find_package(Threads REQUIRED)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

cmake_policy(SET CMP0071 NEW)

if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.17.0")
    cmake_policy(SET CMP0100 NEW)
endif()

message(" ")
message("Qv2ray Version: ${QV2RAY_VERSION_STRING}")
message("Qv2ray Build Version: ${QV2RAY_BUILD_VERSION}")
message("|-------------------------------------------------|")
message("| Qv2ray, A Cross Platform v2ray Qt GUI Client.   |")
message("| Licenced under GPLv3                            |")
message("|                                                 |")
message("| You may only use this program to the extent     |")
message("| permitted by local law.                         |")
message("|                                                 |")
message("| See: https://www.gnu.org/licenses/gpl-3.0.html  |")
message("|-------------------------------------------------|")
message("| Project Homepage: https://github.com/Qv2ray     |")
message("| Welcome to contribute!                          |")
message("|-------------------------------------------------|")
message(" ")

if(WIN32)
    add_compile_options("/std:c++17")
    add_definitions(-DUNICODE -D_UNICODE)
    add_definitions(-D_WIN32_WINNT=0x600 -D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS)
    set(GUI_TYPE WIN32)
    if(NOT DEFINED CMAKE_TOOLCHAIN_FILE)
        if(CMAKE_CL_64)
            include(${CMAKE_SOURCE_DIR}/libs/x64-windows/scripts/buildsystems/vcpkg.cmake)
        else()
            include(${CMAKE_SOURCE_DIR}/libs/x86-windows/scripts/buildsystems/vcpkg.cmake)
        endif()
    endif()
endif()

# ==================================================================================
# Qv2ray Build Arguments
# ==================================================================================
set(QV2RAY_QNODEEDITOR_PROVIDER "module" CACHE STRING "qnodeeditor provider")
set(QV2RAY_ZXING_PROVIDER "module" CACHE STRING "zxing-cpp provider")
if (ANDROID)
else()
    set(QV2RAY_SINGLEAPPLICATION_PROVIDER "module" CACHE STRING "SingleApplication provider")
endif()
set(QV2RAY_DEFAULT_VASSETS_PATH "unset" CACHE STRING "v2ray assets path")
set(QV2RAY_DEFAULT_VCORE_PATH "unset" CACHE STRING "v2ray core path")
set(QV2RAY_TRANSLATION_PATH "unset" CACHE STRING "Qv2ray translations path")
set(QV2RAY_DISABLE_AUTO_UPDATE OFF CACHE BOOL "Disable update checker")
set(BUILD_TESTING OFF CACHE BOOL "Build test")
set(EMBED_TRANSLATIONS OFF CACHE BOOL "Embed translations")
set(QV2RAY_AUTO_DEPLOY ON CACHE BOOL "Automatically run deploy command after build")

if(QV2RAY_DEFAULT_VASSETS_PATH AND NOT QV2RAY_DEFAULT_VASSETS_PATH STREQUAL "unset")
    add_definitions(-DQV2RAY_DEFAULT_VASSETS_PATH="${QV2RAY_DEFAULT_VASSETS_PATH}")
endif()

if(QV2RAY_DEFAULT_VCORE_PATH AND NOT QV2RAY_DEFAULT_VCORE_PATH STREQUAL "unset")
    add_definitions(-DQV2RAY_DEFAULT_VCORE_PATH="${QV2RAY_DEFAULT_VCORE_PATH}")
endif()

if(QV2RAY_TRANSLATION_PATH AND NOT QV2RAY_TRANSLATION_PATH STREQUAL "unset")
    add_definitions(-DQV2RAY_TRANSLATION_PATH="${QV2RAY_TRANSLATION_PATH}")
endif()

if(QV2RAY_DISABLE_AUTO_UPDATE)
    add_definitions(-DDISABLE_AUTO_UPDATE)
endif()

if(FALL_BACK_TO_XDG_OPEN)
    add_definitions(-DFALL_BACK_TO_XDG_OPEN)
endif()

if(EMBED_TRANSLATIONS)
    add_definitions(-DEMBED_TRANSLATIONS)
    configure_file(translations/translations.qrc ${CMAKE_BINARY_DIR} COPYONLY)
    set(QV2RAY_EMBED_TRANSLATION_QRC ${CMAKE_BINARY_DIR}/translations.qrc)
endif()


# ==================================================================================
# 3rdparty Sources
# ==================================================================================
include(cmake/translations.cmake)
include(cmake/qnodeeditor.cmake)
if (ANDROID)
else()
    include(cmake/singleapplication.cmake)
    include(cmake/protobuf.cmake)
    include(cmake/backend.cmake)
endif()
include(cmake/zxing-cpp.cmake)
include(cmake/libsemver.cmake)


# ==================================================================================
# Qv2ray Build Info
# ==================================================================================
if(QV2RAY_BUILD_INFO)
    set(_QV2RAY_BUILD_INFO_STR_ "${QV2RAY_BUILD_INFO}")
elseif(DEFINED ENV{_QV2RAY_BUILD_INFO_})
    set(_QV2RAY_BUILD_INFO_STR_ "$ENV{_QV2RAY_BUILD_INFO_}")
else()
    set(_QV2RAY_BUILD_INFO_STR_ "Qv2ray from manual build")
endif()

if(QV2RAY_BUILD_EXTRA_INFO)
    set(_QV2RAY_BUILD_EXTRA_INFO_STR_ "${QV2RAY_BUILD_EXTRA_INFO}")
elseif(DEFINED ENV{_QV2RAY_BUILD_EXTRA_INFO_})
    set(_QV2RAY_BUILD_EXTRA_INFO_STR_ "$ENV{_QV2RAY_BUILD_EXTRA_INFO_}")
else()
    set(_QV2RAY_BUILD_EXTRA_INFO_STR_ "Qv2ray ${QV2RAY_VERSION_STRING}:${QV2RAY_BUILD_VERSION}")
endif()

set(QV2RAY_BUILD_INFO ${_QV2RAY_BUILD_INFO_STR_})
set(QV2RAY_BUILD_EXTRA_INFO ${_QV2RAY_BUILD_EXTRA_INFO_STR_})

add_definitions(-D_QV2RAY_BUILD_INFO_STR_="${_QV2RAY_BUILD_INFO_STR_}")
add_definitions(-D_QV2RAY_BUILD_EXTRA_INFO_STR_="${_QV2RAY_BUILD_EXTRA_INFO_STR_}")
message("Qv2ray build info: ${_QV2RAY_BUILD_INFO_STR_}")
message("Qv2ray build info ex: ${_QV2RAY_BUILD_EXTRA_INFO_STR_}")


# ==================================================================================
# Plugin Interface Headers
# ==================================================================================
set(QVPLUGIN_INTERFACE_INCLUDE_DIR "src/plugin-interface")
include(src/plugin-interface/QvPluginInterface.cmake)


# ==================================================================================
# Qv2ray Sources and Headers
# ==================================================================================
include(cmake/components/qv2ray-lib.cmake)
include(cmake/components/qv2ray-ui.cmake)
include(3rdparty/uistyles/uistyles.cmake)

set(QRC_RESOURCES
    ${UISTYLE_QRCS}
    ${CMAKE_SOURCE_DIR}/resources.qrc)

# Qv2ray baselib
add_library(qv2ray-baselib STATIC
    ${QV2RAY_BASE_HEADERS}
    ${QV2RAY_LIB_SOURCES}
    ${QVPLUGIN_INTERFACE_HEADERS}
    ${LIBSEMVER_SOURCES}
    ${PROTO_SRCS}
    ${PROTO_HDRS}
    ${API_GRPC_SRCS}
    ${API_PROTO_SRCS}
    )

set(QV2RAY_FULL_SOURCES
    src/main.cpp
    assets/qv2ray.rc
    ${QV2RAY_UI_FORMS}
    ${QV2RAY_UI_SOURCES}
    ${SINGLEAPPLICATION_SOURCES}
    ${QNODEEDITOR_QRC_RESOURCES}
    ${QV2RAY_EMBED_TRANSLATION_QRC}
    ${QRC_RESOURCES}
    ${QM_FILES})

if(ANDROID)
    add_library(qv2ray SHARED ${QV2RAY_FULL_SOURCES})
    target_link_libraries(qv2ray -llog -landroid)
else()
    add_executable(qv2ray ${GUI_TYPE} ${QV2RAY_FULL_SOURCES})
endif()


target_link_libraries(qv2ray-baselib
    ${QV2RAY_PROTOBUF_LIBRARY}
    ${QV2RAY_BACKEND_LIBRARIES}
    ${ZXING_LIBRARY}
    Threads::Threads
    ${QV2RAY_QT_LIBS}
    )

target_link_libraries(qv2ray
    qv2ray-baselib
    ${QNODEEDITOR_LIBRARY}
    ${SINGLEAPPLICATION_LIBRARY}
    )

target_include_directories(qv2ray PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}
    ${QNODEEDITOR_INCLUDE_PATH}
    ${SINGLEAPPLICATION_DIR}
    ${Protobuf_INCLUDE_DIRS}
    )

target_include_directories(qv2ray-baselib PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${ZXING_INCLUDE_PATH}
    ${Protobuf_INCLUDE_DIRS}
    )

if (BUILD_TESTING)
    include(CTest)
    add_subdirectory(test)
endif()

# Qt language translations
add_custom_target(lupdate
    COMMAND lupdate ${QV2RAY_BASE_HEADERS}
    ${QV2RAY_LIB_SOURCES}
    ${QVPLUGIN_INTERFACE_HEADERS}
    ${QV2RAY_UI_SOURCES}
    ${QV2RAY_UI_FORMS}
    ${QNODEEDITOR_QRC_RESOURCES}
    ${SINGLEAPPLICATION_SOURCES} -ts ${TRANSLATIONS_TS} -locations none -noobsolete
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
set_target_properties(lupdate PROPERTIES EXCLUDE_FROM_ALL TRUE)

if(APPLE)
    find_package(Iconv REQUIRED)
    find_library(CARBON NAMES Carbon)
    find_library(COCOA NAMES Cocoa)
    find_library(SECURITY NAMES Security)
    target_link_libraries(qv2ray
        Iconv::Iconv
        ${CARBON}
        ${COCOA}
        ${SECURITY}
        )
    target_include_directories(qv2ray PRIVATE
        ${Iconv_INCLUDE_DIR}
        )

    set(MACOSX_ICON "${CMAKE_SOURCE_DIR}/assets/icons/qv2ray.icns")
    set(MACOSX_PLIST "${CMAKE_SOURCE_DIR}/assets/MacOSXBundleInfo.plist.in")
    set_source_files_properties(${QM_FILES}
        PROPERTIES
        MACOSX_PACKAGE_LOCATION Resources/lang
        )

    target_sources(qv2ray PRIVATE
        ${MACOSX_ICON}
        )

    set_target_properties(qv2ray
        PROPERTIES
        MACOSX_BUNDLE TRUE
        MACOSX_BUNDLE_INFO_PLIST ${MACOSX_PLIST}
        MACOSX_BUNDLE_BUNDLE_NAME "Qv2ray"
        MACOSX_BUNDLE_BUNDLE_VERSION ${QV2RAY_VERSION_STRING}
        MACOSX_BUNDLE_COPYRIGHT "Copyright (c) 2019-2020 Qv2ray Development Group"
        MACOSX_BUNDLE_GUI_IDENTIFIER "com.github.qv2ray"
        MACOSX_BUNDLE_ICON_FILE "qv2ray.icns"
        MACOSX_BUNDLE_INFO_STRING "Created by Qv2ray development team"
        MACOSX_BUNDLE_LONG_VERSION_STRING ${QV2RAY_VERSION_STRING}
        MACOSX_BUNDLE_SHORT_VERSION_STRING ${QV2RAY_VERSION_STRING}
        RESOURCE
        ${MACOSX_ICON}
        )

    # Destination paths below are relative to ${CMAKE_INSTALL_PREFIX}

    install(TARGETS qv2ray
        BUNDLE DESTINATION . COMPONENT Runtime
        RUNTIME DESTINATION bin COMPONENT Runtime
        )
    if(QV2RAY_AUTO_DEPLOY)
        add_custom_command(TARGET qv2ray POST_BUILD
            COMMAND ${Qt5_DIR}/../../../bin/macdeployqt ${CMAKE_BINARY_DIR}/qv2ray.app
            )
    endif()
    set(APPS "\${CMAKE_INSTALL_PREFIX}/qv2ray.app")
    include(cmake/deployment.cmake)
endif()

if(UNIX AND NOT APPLE AND NOT WIN32)
    install(TARGETS qv2ray RUNTIME DESTINATION bin)
    install(FILES assets/qv2ray.metainfo.xml DESTINATION share/metainfo)
    install(FILES assets/qv2ray.desktop DESTINATION share/applications)
    install(FILES assets/icons/qv2ray.png DESTINATION share/icons/hicolor/256x256/apps)
    if(NOT EMBED_TRANSLATIONS)
        install(FILES ${QM_FILES} DESTINATION share/qv2ray/lang)
    endif()
endif()

if(WIN32)
    find_package(OpenSSL REQUIRED)
    target_link_libraries(qv2ray-baselib wininet wsock32 ws2_32 user32 Iphlpapi OpenSSL::SSL OpenSSL::Crypto Dbghelp)

=== debian/changelog ===
qv2ray (2.6.0-1) unstable; urgency=medium

  * New Release 2.6.0

 -- Guobang Bi <ymshenyu@gmail.com>  Thu, 09 Jul 2020 22:04:57 +0800

qv2ray (2.6.0~rc6-1) unstable; urgency=medium

  * New Release 2.6.0-rc6

 -- Guobang Bi <ymshenyu@gmail.com>  Wed, 08 Jul 2020 21:43:01 +0800

qv2ray (2.6.0~rc5-1) unstable; urgency=medium

  * New Release 2.6.0-rc5

 -- Guobang Bi <ymshenyu@gmail.com>  Mon, 06 Jul 2020 17:37:41 +0800

qv2ray (2.6.0~rc4-1) unstable; urgency=medium

  * fix: fixed ssd:// order issue, fixed #635
  * add: remove connections via delete key
  * add: added qv2ray://
  * add: use env QV2RAY_CONFIG_PATH to specify config path, make darkmode theme cross-platform, refactor
  * add: introducing Qv2rayApplication

 -- Guobang Bi <ymshenyu@gmail.com>  Thu, 18 Jun 2020 16:10:05 +0800

qv2ray (2.6.0~rc3-1) unstable; urgency=medium

  * add: added DNS Settings and GroupRouteManager
  * fix: bgcolor can't switch to default when swiching to flatwhite/psblack and then back to breeze or other
  * refactor: change include structure
  * fix: sort groups by displayName
  * fix: improve GroupManager performance by 5000%
  * fix: fixed Recent Connections jumplist
  * fix: fixed EMBED_TRANSLATIONS option
  * fix: prevent reading geosite/geoip every time
  * add: added ICMP as latency tester
  
 -- Guobang Bi <ymshenyu@gmail.com>  Wed, 27 May 2020 18:17:03 +0800

qv2ray (2.6.0~rc2-1) unstable; urgency=medium

  * fix: fixed tcping message
  * refactor: refactored auto update algorithm
  * fix: fixed Windows non-block TCPing
  * fix: UI tweak, prevent connection list taking too much space

 -- Guobang Bi <ymshenyu@gmail.com>  Mon, 18 May 2020 12:01:50 +0800

qv2ray (2.6.0~rc1-1) unstable; urgency=medium

  * NTP Check
  * Port Detection
  * Introduce unit test
  * Introduce group editor/manager
  * added vmess v1 upgrader (close #609)
  * Refactor system proxy  

 -- Guobang Bi <ymshenyu@gmail.com>  Sun, 17 May 2020 20:23:35 +0800

qv2ray (2.5.0-1) unstable; urgency=medium

  * updating translations
  * add: added Latency Test on the connection list RCM, fixed #539
  * rejecting trash v2rayN vmess schema v1
  * add: use UseIP when tProxy and DNSIntercept have been enabled
  * fix: fixed a missing IPv6 CIDR address
  * fix: fixed a missing IP rule when proxy is disabled

 -- Guobang Bi <ymshenyu@gmail.com>  Sun, 26 Apr 2020 19:03:35 +0800

qv2ray (2.5.0~rc1-1) unstable; urgency=medium

  * add dns intercept and route for tproxy
  * prevent loopback
  * fix: allow dns outbound have mark too
  * fix: refactored Qv2ray Proxy settings

 -- Guobang Bi <ymshenyu@gmail.com>  Sat, 25 Apr 2020 10:29:07 +0800

qv2ray (2.5.0~pre2-1) unstable; urgency=medium

  * fix: skip saving config when importing multiple connection configs
  * add: ignore updating subscription by setting interval to 0
  * fix: fixed a missing signal emit
  * update: updated label text, fixed a spelling misATke
  * add: added kernel plugin support

 -- Guobang Bi <ymshenyu@gmail.com>  Sat, 11 Apr 2020 23:12:20 +0800

qv2ray (2.4.1-1) unstable; urgency=medium

  * add: add new semver checker
  * add: added support of ssd:// fixed #372
  * fix: apply tabStop sequences by @DuckSoft
  * fix: increase configuration save frequency
  * fix: fixed SOCKS user removal issue

 -- Guobang Bi <ymshenyu@gmail.com>  Wed, 01 Apr 2020 14:51:15 +0800

qv2ray (2.4.0~pre1-1) unstable; urgency=medium

  * change: ported to zxing-cpp
  * fixed: fixed #else condition in DISABLE_AUTO_UPDATE
  * fix: fixed domainStrategy export and MainWindow button icon color scheme change event

 -- Guobang Bi <ymshenyu@gmail.com>  Fri, 27 Mar 2020 23:15:16 +0800

qv2ray (2.3.2-1) unstable; urgency=medium

  * Fix Strange Button Length

 -- Guobang Bi <ymshenyu@gmail.com>  Sun, 22 Mar 2020 20:33:31 +0800

qv2ray (2.3.1-1) unstable; urgency=medium

  * fixed file loading if a source file was not in UTF-8

 -- Guobang Bi <ymshenyu@gmail.com>  Sat, 21 Mar 2020 08:50:17 +0800

qv2ray (2.3.0-1) unstable; urgency=medium

  * misc ui tweaks
  * fully support setting the block,proxy,direct geosite/plain domains
  * fixed vmess:// 'h2' import issue

 -- Guobang Bi <ymshenyu@gmail.com>  Fri, 20 Mar 2020 22:26:20 +0800

qv2ray (2.2.3-1) unstable; urgency=medium

  * Initial release

 -- Guobang Bi <ymshenyu@gmail.com>  Fri, 20 Mar 2020 08:47:53 +0800

=== debian/control ===
Source: qv2ray
Section: net
Priority: optional
Maintainer: Guobang Bi <ymshenyu@gmail.com>
Uploaders: Boyuan Yang <byang@debian.org>
Build-Depends:  debhelper (>= 11),
                cmake (>= 3.10.1),
                ninja-build,
                libgrpc++-dev (>= 1.16.1-1~),
                libprotobuf-dev (>= 3.6.1.3-1~),
                protobuf-compiler (>= 3.6.1.3-1~),
                protobuf-compiler-grpc (>= 1.16.1-1~),
                qtbase5-dev (>= 5.11.3-1~),
                qtdeclarative5-dev (>= 5.11.3-1~),
                qttools5-dev (>= 5.11.3-1~)
Standards-Version: 4.5.0
Homepage: https://github.com/Qv2ray/Qv2ray
Vcs-Browser: https://salsa.debian.org/debian/qv2ray
Vcs-Git: https://salsa.debian.org/debian/qv2ray.git

Package: qv2ray
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: v2ray
Description: Qt frontend for v2ray
 Project Qv2ray is a flexable cross platform Qt GUI client for V2ray.
 It makes everything easier by using GUI editors. It also supports
 ShadowsicksR, Trojan and NaiveProxy by making them plugins.
